package forkjoin;

import java.util.concurrent.RecursiveAction;

class ForkJoinPoolAction extends RecursiveAction {
    /**
     *
     */
    private static final long serialVersionUID = -6423407346230649936L;

    static final int SEQUENTIAL_THRESHOLD = 10000;
    long result = 0;

    int low;
    int high;
    int[] array;

    public ForkJoinPoolAction(int[] arr, int low, int high) {
        this.array = arr;
        this.low = low;
        this.high = high;
    }

    @Override
    protected void compute() {
        if (this.high - this.low <= SEQUENTIAL_THRESHOLD) {
            long sum = 0;
            for (int i = this.low; i < this.high; ++i) {
                sum += this.array[i] / i / i;
            }
            this.result = sum;
        } else {
            int mid = this.low + (this.high - this.low) / 2;
            ForkJoinPoolAction left = new ForkJoinPoolAction(this.array, this.low, mid);
            left.compute();
            ForkJoinPoolAction right = new ForkJoinPoolAction(this.array, mid, this.high);
            right.compute();
            this.result = left.result + right.result;
        }
    }
}