package forkjoin;

import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.RecursiveAction;
import java.util.concurrent.RecursiveTask;

public class ForkJoinPoolDemo {
    private static int array[] = new int[1000000000];

    public static void main(String[] args) {
        Runtime runtime = Runtime.getRuntime();
        int procCount = runtime.availableProcessors();
        System.out.println(procCount + " processors available");

        long startTime = 0;
        long endTime = 0;

        for (int i = 0; i < array.length; i++) {
            array[i] = i * i * i;
        }

        startTime = System.currentTimeMillis();
        long sum = 0;
        for (int i = 1; i < array.length; ++i) {
            sum += array[i] / i / i;
        }
        endTime = System.currentTimeMillis();
        System.out.println("sequentiell sum " + sum);
        System.out.println("time " + (endTime - startTime));

        ForkJoinPool forkJoinPool = new ForkJoinPool();
        startTime = System.currentTimeMillis();
        ForkJoinPoolAction computeSum = new ForkJoinPoolAction(array, 1, array.length);
        endTime = System.currentTimeMillis();
        System.out.println("parallel    sum " + computeSum.result);
        System.out.println("time " + (endTime - startTime));
    }

}